package com.yanzuoguang.util.helper;

import com.yanzuoguang.util.exception.CodeException;

import java.net.URLDecoder;
import java.net.URLEncoder;

/**
 * 地址字符串处理
 */
public class UrlHelper {
    /**
     * 转换为%E4%BD%A0形式
     *
     * @param s
     * @param encoding
     * @return
     */
    public static String encoding(String s, String encoding) {
        try {
            StringBuffer sb = new StringBuffer();
            for (int i = 0; i < s.length(); i++) {
                char c = s.charAt(i);
                if (c >= 0 && c <= 255) {
                    sb.append(c);
                } else {
                    String t = URLEncoder.encode("" + c, encoding);
                    sb.append(t);
                }
            }
            return sb.toString();
        } catch (Exception ex) {
            throw new CodeException(ex);
        }
    }

    /**
     * 将%E4%BD%A0转换为汉字
     *
     * @param s
     * @param encoding
     * @return
     */
    public static String decoding(String s, String encoding) {
        try {
            return URLDecoder.decode(s, encoding);
        } catch (Exception ex) {
            throw new CodeException(ex);
        }
    }
}