package com.yanzuoguang.util.thread;

import com.yanzuoguang.util.exception.CodeException;

/**
 * 根据指定的线程数量， 执行多个Runnable对象
 */
public class RunnableList extends ThreadList<Runnable> {
    /**
     * 线程数量
     *
     * @param threadCount
     */
    public RunnableList(int threadCount) {
        super(threadCount);
    }

    /**
     * 执行的具体函数
     *
     * @param item 需要处理的数据
     */
    @Override
    public void run(Runnable item) {
        try {
            item.run();
        } catch (RuntimeException ex) {
            throw ex;
        } catch (Exception ex) {
            throw new CodeException(ex.getMessage(), ex);
        }
    }
}
