package com.yanzuoguang.util.vo;

/**
 * 分页实现对象
 * Created by yanzu on 2017/5/30.
 */
public class PageSizeReqVo extends BaseVo implements PageSizeReq {

    private static final long serialVersionUID = -3933114440447495323L;
    /**
     * 当前第几页
     */
    private int pageIndex = 1;

    /**
     * 当前页面所包含的记录数量
     */
    private int pageSize = 20;

    /**
     * 构造函数
     */
    public PageSizeReqVo() {
        this(1, 20);
    }

    /**
     * 构造函数
     *
     * @param pageIndex 第几页
     * @param pageSize  每页大小
     */
    public PageSizeReqVo(int pageIndex, int pageSize) {
        this.pageIndex = pageIndex;
        this.pageSize = pageSize;
    }

    /**
     * 获取记录开始的编号
     *
     * @return 返回记录开始的编号
     */
    public int getPageStart() {
        int pageIndex = this.pageIndex > 0 ? this.pageIndex : 1;
        return (pageIndex - 1) * this.pageSize;
    }

    /**
     * 获取记录结束的编号
     *
     * @return 返回记录结束的编号
     */
    public int getPageEnd() {
        int pageIndex = this.pageIndex > 0 ? this.pageIndex : 1;
        return pageIndex * this.pageSize;
    }

    public int getPageIndex() {
        return pageIndex;
    }

    public PageSizeReqVo setPageIndex(int pageIndex) {
        this.pageIndex = pageIndex;
        return this;
    }

    public int getPageSize() {
        return pageSize;
    }

    public PageSizeReqVo setPageSize(int pageSize) {
        this.pageSize = pageSize;
        return this;
    }
}
