package com.yanzuoguang.service;

import java.util.List;

/**
 * 基本服务接口
 * created by yanzu on 2017/5/29.
 */
public interface BaseService<T> {
    /**
     * 创建数据
     *
     * @param models 需要创建的数据
     */
    List<String> create(T... models);

    /**
     * 修改数据
     *
     * @param models 需要修改的数据
     */
    List<String> update(T... models);

    /**
     * 保存数据
     *
     * @param models 需要保存的数据
     */
    List<String> save(T... models);

    /**
     * 删除数据
     *
     * @param models 需要删除的数据
     */
    List<String> remove(T... models);

    /**
     * 加载数据
     *
     * @param models 需要删除的数据
     */
    List<T> load(T... models);
}
